

document.getElementById("buttonSendToMotas").onclick = function() {functionSendToMotas()};
document.getElementById("buttonReceiveFromMotas").onclick = function() {functionReceiveFromMotas()};
document.getElementById("buttonSaveToFile").onclick = function() {functionSaveToFile()};
document.getElementById("loadFromFile").addEventListener('change', functionLoadFromFile, false);

document.getElementById("patchesList").addEventListener('change', function(){updatePatchUI(-1, false, true, MIDI_SYSEX_PATCH_TRANSFER)});
document.getElementById("patternsList").addEventListener('change', function(){updatePatchUI(-1, false, true, MIDI_SYSEX_PATTERN_TRANSFER)});
document.getElementById("sequencesList").addEventListener('change', function(){updatePatchUI(-1, false, true, MIDI_SYSEX_SEQUENCE_TRANSFER)});


document.getElementById("nameInput").addEventListener('change', function(){nameEdited()});


function nameEdited()
{
	
	debugMessage('name edited');
	
	var row =  getActiveRow();
	 
	 
	//QByteArray b = QByteArray(ui->lineEditName->text().toUtf8(), ui->lineEditName->text().length());


	var name =  document.getElementById("nameInput").value;
	var type;

    for (var i = 0; i < NAME_LENGTH ; i++)
    {
    	var val = name.charCodeAt(i);
        //quint8 val = b.at(i);
        if (val < 32 || val >= 0x7F)
            val = 32;
        
        switch (modePatchPatternSeq)
        {
        default:
        case 0:
        	type = MIDI_SYSEX_PATCH_TRANSFER;
        	patchBuffer[i + 8] = val;
        	break;
        case 1:
        	type = MIDI_SYSEX_PATTERN_TRANSFER;
        	patternBuffer[i + 8] = val;
        	break;
        case 2:
        	type = MIDI_SYSEX_SEQUENCE_TRANSFER;
        	sequenceBuffer[i + 8] = val;
        	break;
        }
        
        /*
        switch (ui->tabWidgetDataType->currentIndex())
        {
            case 0:
                patchBuffer[i + 8] = val;
                break;
            case 1:
                patternBuffer[i + 8] = val;
                break;
            case 2:
                sequenceBuffer[i + 8] = val;
               break;
        }*/
    }

    //updateCurrentDisplayData();
    
    
	updatePatchUI(row, true, true, type);
			
}

//document.getElementById("checkBoxRequestScreenshot"). = function() {functionRequestScreenShot()};

function functionSendToMotas()
{
	debugMessage('send', 'to Motas');
	
	//var preset = getActiveRow();
	var id = getMIDIOutId();
	
	var modelNum = document.getElementById("motasModel").value;
	var channel = document.getElementById("midiChannel").value - 1;

	if (modeSingleBank == 0)
	{
		sendSingleData(id, modelNum, channel);
		
	} else
	{
		// send all 
		sendBankData(id, modelNum, channel);
	}

}

function sendSingleData(id, modelNum, channel)
{
    var bytesToSend;
 
	var bank = 0x7E; // RAM only
	
	
	
    switch(modePatchPatternSeq)
    {
        case 0:
        	var preset =  document.getElementById("destinationPatch").selectedIndex;		
        	bytesToSend = prepareSysExPacketsFromUnpacked(rawTransferBuffer,
                    patchBuffer, PATCH_LENGTH_BYTES_UNPACKED, MIDI_SYSEX_PATCH_TRANSFER, bank, preset, 0, modelNum, channel);
			
            break;
        case 1:
        	var preset =  document.getElementById("destinationPattern").selectedIndex;		
        	bytesToSend = prepareSysExPacketsFromUnpacked(rawTransferBuffer,
                    patternBuffer, PATTERN_LENGTH_BYTES_UNPACKED, MIDI_SYSEX_PATTERN_TRANSFER, bank, preset, 0, modelNum, channel);
			
            break;
        case 2:
        	var preset =  document.getElementById("destinationSequence").selectedIndex;		
        	bytesToSend = prepareSysExPacketsFromUnpacked(rawTransferBuffer,
                    sequenceBuffer, SEQUENCE_LENGTH_BYTES_UNPACKED, MIDI_SYSEX_SEQUENCE_TRANSFER, bank, preset, 0, modelNum, channel);
			
         break;
    }
    //debugMessage('patchBuffer: ' + patchBuffer);
    
  //  debugMessage('bytesToSend: ' + bytesToSend);

   // debugMessage('rawTransferBuffer: ' + rawTransferBuffer);
    sendDataOverMIDIDirect(id, rawTransferBuffer, bytesToSend);
}

function sendBankData(id, modelNum, channel)
{
    var bytesToSend;
 
	
    switch(modePatchPatternSeq)
    {
        case 0:
        	
        	var newBuf = new Uint8Array(PATCH_LENGTH_BYTES_UNPACKED * BANK_OF_PATCHES_LENGTH);
			for (var i = 0; i < BANK_OF_PATCHES_LENGTH; i++)
			{
				newBuf.set(bankOfPatches[i], i * PATCH_LENGTH_BYTES_UNPACKED);
			}
						
			
        	var bank =  document.getElementById("destinationPatchBank").selectedIndex;		
        	bytesToSend = prepareSysExPacketsFromUnpacked(rawTransferBuffer,
        			newBuf, PATCH_LENGTH_BYTES_UNPACKED * BANK_OF_PATCHES_LENGTH, 
                    MIDI_SYSEX_PATCH_BANK_TRANSFER, bank, 0, 0, modelNum, channel);
			
            break;
        case 1:
        	var newBuf = new Uint8Array(PATTERN_LENGTH_BYTES_UNPACKED * BANK_OF_PATTERNS_LENGTH);
			for (var i = 0; i < BANK_OF_PATTERNS_LENGTH; i++)
			{
				newBuf.set(bankOfPatterns[i], i * PATTERN_LENGTH_BYTES_UNPACKED);
			}
			
			
        	var bank =  document.getElementById("destinationPatternBank").selectedIndex;		
        	bytesToSend = prepareSysExPacketsFromUnpacked(rawTransferBuffer,
                    patternBuffer, PATTERN_LENGTH_BYTES_UNPACKED * BANK_OF_PATTERNS_LENGTH, 
                    MIDI_SYSEX_PATTERN_BANK_TRANSFER, bank, 0, 0, modelNum, channel);
			
            break;
        case 2:
        	var newBuf = new Uint8Array(SEQUENCE_LENGTH_BYTES_UNPACKED * BANK_OF_SEQUENCES_LENGTH);
			for (var i = 0; i < BANK_OF_SEQUENCES_LENGTH; i++)
			{
				newBuf.set(bankOfPatterns[i], i * SEQUENCE_LENGTH_BYTES_UNPACKED);
			}
			
        	var bank =  document.getElementById("destinationSequenceBank").selectedIndex;		
        	bytesToSend = prepareSysExPacketsFromUnpacked(rawTransferBuffer,
                    sequenceBuffer, SEQUENCE_LENGTH_BYTES_UNPACKED * BANK_OF_SEQUENCES_LENGTH, 
                    MIDI_SYSEX_SEQUENCE_BANK_TRANSFER, bank, 0, 0, modelNum, channel);
			
         break;
    }
    //debugMessage('patchBuffer: ' + patchBuffer);
    
  //  debugMessage('bytesToSend: ' + bytesToSend);

   // debugMessage('rawTransferBuffer: ' + rawTransferBuffer);
    sendDataOverMIDIDirect(id, rawTransferBuffer, bytesToSend);
}


function functionReceiveFromMotas()
{
	var modelNum = Number(document.getElementById("motasModel").value);
	var channel = document.getElementById("midiChannel").value - 1;

	var id = getMIDIOutId();
	debugMessage("request from Motas, type: " + modePatchPatternSeq);
	if (modeSingleBank == 0)
	{
		switch(modePatchPatternSeq)
		{
			case 0:
				sendMIDISysExCommand(id, modelNum, channel, MIDI_SYSEX_REQUEST_PATCH, 0);
				break;
			case 1:
				sendMIDISysExCommand(id, modelNum, channel, MIDI_SYSEX_REQUEST_PATTERN, 0);
				break;
			case 2:
				sendMIDISysExCommand(id, modelNum, channel, MIDI_SYSEX_REQUEST_SEQUENCE, 0);
				break;
			default:
				break;
		}
	}
	else
	{
		switch (modePatchPatternSeq)
		{
			case 0:
				var bank =  document.getElementById("destinationPatchBank").selectedIndex;		
				sendMIDISysExCommand(id, modelNum, channel, MIDI_SYSEX_REQUEST_PATCHES_BANK, bank );
				break;
			case 1:
				var bank =  document.getElementById("destinationPatternBank").selectedIndex;		
				sendMIDISysExCommand(id, modelNum, channel, MIDI_SYSEX_REQUEST_PATTERN_BANK, bank );
				break;
			case 2:
				var bank =  document.getElementById("destinationSequenceBank").selectedIndex;		
				sendMIDISysExCommand(id, modelNum, channel, MIDI_SYSEX_REQUEST_SEQUENCE_BANK, bank );
				break;
			default:
				break;
		}
	}
}


function functionSaveToFile()
{
	
	debugMessage('save');

	
	/*var
    buffer = new ArrayBuffer(8) // allocates 8 bytes
  , data = new DataView(buffer)
	;
	//You can write uint8/16/32s and float32/64s to dataviews
	data.setUint8 (0, 0x01);
	data.setUint16(1, 0x2345);
	data.setUint32(3, 0x6789ABCD);
	data.setUint8 (7, 0xEF);
*/
	var buffer;
	var data;
	var extension;
	
	var bufferLength;
	var startItemIndex;
	var endItemIndex;
	switch(modePatchPatternSeq)
	{
	default:
	case 0:
		if (modeSingleBank == 0)
		{
			extension = "patch";
			bufferLength = PATCH_LENGTH_BYTES_UNPACKED;
			startItemIndex = getActiveRow();
			endItemIndex = startItemIndex + 1;
		} else
		{
			extension = "bpatch";	
			startItemIndex  = 0;
			endItemIndex = BANK_OF_PATCHES_LENGTH;
			bufferLength = BANK_OF_PATCHES_LENGTH * PATCH_LENGTH_BYTES_UNPACKED;
		}
		buffer = new ArrayBuffer(bufferLength);
		data = new DataView(buffer);
		for (var i = 0; i < (endItemIndex - startItemIndex); i++)
		{
			for (var j = 0; j < PATCH_LENGTH_BYTES_UNPACKED; j++)
			{
				data.setUint8(i * PATCH_LENGTH_BYTES_UNPACKED + j, bankOfPatches[startItemIndex + i][j]);
			}
		}
		break;
	case 1:
		if (modeSingleBank == 0)
		{
			extension = "pattern";
			bufferLength = PATTERN_LENGTH_BYTES_UNPACKED;
			startItemIndex = getActiveRow();
			endItemIndex = startItemIndex + 1;
		} else
		{
			extension = "bpattern";
			startItemIndex  = 0 ;
			endItemIndex = BANK_OF_PATTERNS_LENGTH;
			bufferLength = BANK_OF_PATTERNS_LENGTH * PATTERN_LENGTH_BYTES_UNPACKED;

		}
		buffer = new ArrayBuffer(bufferLength);
		data = new DataView(buffer);
		for (var i = 0; i < (endItemIndex - startItemIndex); i++)
		{
			for (var j = 0; j < PATTERN_LENGTH_BYTES_UNPACKED; j++)
			{
				data.setUint8(i * PATTERN_LENGTH_BYTES_UNPACKED + j, bankOfPatterns[startItemIndex + i][j]);
			}
		}
		
		break;
	case 2:
		if (modeSingleBank == 0)
		{
			extension = "seq";
			bufferLength = SEQUENCE_LENGTH_BYTES_UNPACKED;
			startItemIndex  = 0 ;
			endItemIndex = startItemIndex + 1;
		} else
		{
			extension = "bseq";
			bufferLength = BANK_OF_SEQUENCES_LENGTH * SEQUENCE_LENGTH_BYTES_UNPACKED;
			startItemIndex  = 0 ;
			endItemIndex = BANK_OF_SEQUENCES_LENGTH;
		}
		buffer = new ArrayBuffer(bufferLength);
		data = new DataView(buffer);
		for (var i = 0; i < (endItemIndex - startItemIndex); i++)
		{
			for (var j = 0; j < SEQUENCE_LENGTH_BYTES_UNPACKED; j++)
			{
				data.setUint8(i * SEQUENCE_LENGTH_BYTES_UNPACKED + j, bankOfSequences[startItemIndex + i][j]);
			}
		}
		break;
	}
	var fileName;
	if (modeSingleBank == 0)
	{
		fileName = document.getElementById("nameInput").value + "." + extension;
	}
	else
	{
		fileName = "MOTAS_BANK." + extension;
	}
	saveAs(new Blob([data], {type: "example/binary"}), fileName);
}

function getActiveRow()
{
	var index;
	switch (modePatchPatternSeq)
	{
	case 0:
		index = document.getElementById('patchesList').selectedIndex;
		break;
	case 1:
		index = document.getElementById('patternsList').selectedIndex;
		break;
	case 2:
		index = document.getElementById('sequencesList').selectedIndex;
		break;
	}
	debugMessage('active row: ' + index);
	return index;
}



function functionLoadFromFile(e)
{
	  var file = e.target.files[0];
	  if (!file) {
	    return;
	  }
	  //debugMessage('load from file');
	  var reader = new FileReader();
	  reader.readAsArrayBuffer(file);
	  reader.onload = function(e)
	  {
 	  
		  if (modeSingleBank == 0)
		  {
			  	var row =  getActiveRow();
			    debugMessage('load single');
			    var type = -1;
			   
				var size = reader.result.byteLength;
				debugMessage(size);
				switch (modePatchPatternSeq)
				{
					case 0:
						if (size == PATCH_LENGTH_BYTES_UNPACKED)
						{
							
							var newBuf = new Uint8Array(reader.result);
							/*var j = 0;
							for (var i = 0; i < PATCH_LENGTH_BYTES_UNPACKED; i++)
							{
								var value = 0;
								var k = 10;
								while(1)
								{
	
									if (j >= size || ( newBuf[j] < 0x30 || newBuf[j] > 0x39))
									{
										j++;
										break;
									}
									
									value = (newBuf[j] - 0x30) + value * k;
									
									j++;
									
								}
							//	console.log(j, value);
								bankOfPatches[row][i] = value;
							}*/
							bankOfPatches[row] = newBuf;
							
							console.log(newBuf);
							updatePatchUI(row, false, true, MIDI_SYSEX_PATCH_TRANSFER);
							debugMessage('load patch');
						}
					break;
					case 1:
						if (size == PATTERN_LENGTH_BYTES_UNPACKED)
						{
							var newBuf = new Uint8Array(reader.result);
							bankOfPatterns[row] = newBuf;
							updatePatchUI(row, false, true, MIDI_SYSEX_PATTERN_TRANSFER);
							debugMessage('load pattern');
	
						}
					break;
					case 2:
						if (size == SEQUENCE_LENGTH_BYTES_UNPACKED)
						{
							var newBuf = new Uint8Array(reader.result);
							bankOfSequences[row] = newBuf;
							updatePatchUI(row, false, true, MIDI_SYSEX_SEQUENCE_TRANSFER);
							debugMessage('load sequence');
						}
					break;
				}
		  } else
		  {
			  debugMessage('load bank');
			  
			    var size = reader.result.byteLength;
				debugMessage(size);
				switch (modePatchPatternSeq)
				{
					case 0:
						if (size == PATCH_LENGTH_BYTES_UNPACKED * BANK_OF_PATCHES_LENGTH)
						{
							var newBuf = new Uint8Array(reader.result);
							
							for (var i = 0; i < BANK_OF_PATCHES_LENGTH; i++)
							{
								bankOfPatches[i] = newBuf.slice(i * PATCH_LENGTH_BYTES_UNPACKED, (i + 1) * PATCH_LENGTH_BYTES_UNPACKED);
								updatePatchUI(i, false, i == 0 , MIDI_SYSEX_PATCH_BANK_TRANSFER);
							}
							debugMessage('load patch bank');
						}
					break;
					case 1:
						if (size == PATTERN_LENGTH_BYTES_UNPACKED * BANK_OF_PATTERNS_LENGTH)
						{
							var newBuf = new Uint8Array(reader.result);
							for (var i = 0; i < BANK_OF_PATTERNS_LENGTH; i++)
							{
								bankOfPatterns[i] = newBuf.slice(i * PATTERN_LENGTH_BYTES_UNPACKED, (i + 1) * PATTERN_LENGTH_BYTES_UNPACKED);
								updatePatchUI(i, false, i == 0 , MIDI_SYSEX_PATTERN_BANK_TRANSFER);
							}
							debugMessage('load pattern bank');
	
						}
					break;
					case 2:
						if (size == SEQUENCE_LENGTH_BYTES_UNPACKED * BANK_OF_SEQUENCES_LENGTH)
						{
							var newBuf = new Uint8Array(reader.result);
							for (var i = 0; i < BANK_OF_SEQUENCES_LENGTH; i++)
							{
								bankOfSequences[row] = newBuf.slice(i * SEQUENCE_LENGTH_BYTES_UNPACKED, (i + 1) * SEQUENCE_LENGTH_BYTES_UNPACKED);
								updatePatchUI(i, false, i == 0 , MIDI_SYSEX_SEQUENCE_BANK_TRANSFER);
							}
							debugMessage('load sequence bank');
						}
					break;
				}
				
			  
		  }
		    // read in patch from the disk
			 // clear value so can allow load again on repeated press and selection of same file  
			 document.getElementById('loadFromFile').value = "";
	  };
}


function updatePatchUI(row, dataAdjusted, isfinal, type)
{
	if (row == -1)
	{
		row =  getActiveRow();
	}
	
    var identifierType = 0;
    var buf = 0;
    var itemLength = 0;
   
    switch (type)
    {
        case MIDI_SYSEX_PATCH_TRANSFER:
        case MIDI_SYSEX_PATCH_BANK_TRANSFER:
       // 	debugMessage('update UI MIDI_SYSEX_PATCH_TRANSFER');
            patchBuffer =  bankOfPatches[row];
            buf = patchBuffer;
            identifierType = PATCH_IDENTIFIER;
            itemLength = PATCH_LENGTH_BYTES_UNPACKED;
            break;
        case MIDI_SYSEX_PATTERN_TRANSFER:
        case MIDI_SYSEX_PATTERN_BANK_TRANSFER:
            patternBuffer = bankOfPatterns[row];
            buf = patternBuffer;
            identifierType = PATTERN_IDENTIFIER;
            itemLength = PATTERN_LENGTH_BYTES_UNPACKED;
            break;
        case MIDI_SYSEX_SEQUENCE_TRANSFER:
        case MIDI_SYSEX_SEQUENCE_BANK_TRANSFER:
            sequenceBuffer = bankOfSequences[row];
            buf = sequenceBuffer;
            identifierType = SEQUENCE_IDENTIFIER;
            itemLength = SEQUENCE_LENGTH_BYTES_UNPACKED;
            break;
        default:
            return;
    }

    debugMessage('updatePatchUI', row, type);
    if (buf == null)
    	return;
   
    var identifier  = read32(0, buf);
    var itemName = " ";
    debugMessage('identifier', identifier, identifierType);
 //   debugMessage('identifierType', identifierType);
    if (identifier == identifierType)
    {
    	//debugMessage('identifier matched!');
   	 
        var n = [];
        for (var i = 0; i < NAME_LENGTH; i++)
        {
            n[i] = (buf[i + 8]);
            if (n[i] < 32 || n[i] >= 0x7F)
                n[i] = 32;
        }
        itemName = n;
        // populate the name field
      
        //itemName = QString(n, NAME_LENGTH);

        
        if (isfinal)
        {
        	debugMessage('is final');
       	 
          //  ui->lineEditPatchName->setText(patchName);

     //       quint32 version  = Utilities::read32(4 + 4 + NAME_LENGTH, buf) ;
           // ui->lineEditVersion->setText(QString::number(version));
            

            //ui->lineEditCRC32->setText(QString::number(CRC32));

            crcInit();
            // offset of 8 to miss the CRC and identifier bytes
            
            var crcVal = crcFastSTMF4(buf, 8, itemLength - 8); // calculate CRC of all data (excluding first 8 bytes, and final 4)
            //qDebug() <<  "computed CRC: " << crcVal << "for " << itemLength << " byte item";


            if (dataAdjusted)
            {
            	debugMessage('writing new CRC32');
                write32(crcVal, 4, buf); // write new CRC to the patchbuffer
                //CRC32 = crcVal;
            }
            var CRC32  = read32(4, buf);

            var crcCorrect = 0;
            if (crcVal == CRC32)
            {
                crcCorrect = 1;
                debugMessage('CRC correct', crcVal, CRC32);

            } else
            {
            	debugMessage('CRC wrong!', crcVal, CRC32);
                //qDebug() <<  "CRC wrong!";
            }
         //   ui->labelIsCorrupted->setVisible(!crcCorrect);
        //    ui->pushButtonSave->setEnabled(crcCorrect);
         //   ui->pushButtonSend->setEnabled(crcCorrect);
         //   ui->checkBoxCRCcorrect->setChecked(crcCorrect);
        }
    } else
    {
        switch (type)
        {
            case MIDI_SYSEX_PATCH_TRANSFER:
            case MIDI_SYSEX_PATCH_BANK_TRANSFER:
                memset(buf, 0, PATCH_LENGTH_BYTES_UNPACKED);
                break;
            case MIDI_SYSEX_PATTERN_TRANSFER:
            case MIDI_SYSEX_PATTERN_BANK_TRANSFER:
                memset(buf, 0, PATTERN_LENGTH_BYTES_UNPACKED);
                break;
            case MIDI_SYSEX_SEQUENCE_TRANSFER:
            case MIDI_SYSEX_SEQUENCE_BANK_TRANSFER:
                memset(buf, 0, SEQUENCE_LENGTH_BYTES_UNPACKED);
                break;
        }

        debugMessage('identifier wrong');
       // qDebug() << "Identifier incorrect: " << QString::number(identifier, 16);
        if (isfinal)
        {
           // ui->lineEditPatchName->setText(" ");
       //     ui->checkBoxCRCcorrect->setChecked(false);
   //         ui->pushButtonSave->setEnabled(!true);
    //        ui->pushButtonSend->setEnabled(!true);

            //ui->lineEditCRC32->setText("N/A");
          //  ui->lineEditVersion->setText(" ");
        }
    }


    if (isfinal)
    {
	    switch (type)
	    {
	        case MIDI_SYSEX_PATCH_TRANSFER:
	        case MIDI_SYSEX_PATCH_BANK_TRANSFER:
	            	document.getElementById("patchesList").focus();
	            	document.getElementById("patchesList").selectedIndex = row;
	            	break;
	        case MIDI_SYSEX_PATTERN_TRANSFER:
	        case MIDI_SYSEX_PATTERN_BANK_TRANSFER:
	            	document.getElementById("patternsList").focus();
	            	document.getElementById("patternsList").selectedIndex = row;
	            	break;
	        case MIDI_SYSEX_SEQUENCE_TRANSFER:
	        case MIDI_SYSEX_SEQUENCE_BANK_TRANSFER:
	            	document.getElementById("sequencesList").focus();
	            	document.getElementById("sequencesList").selectedIndex = row;
	            	break;
	       default:
	            break;
	    }
       	document.getElementById("nameInput").value = stringFromArray(itemName);
    }
    
   
	if (row < 9)
		itemName = "[0" + (row + 1) + "]" + stringFromArray(itemName);
	else
		itemName = "[" + (row + 1) + "]" + stringFromArray(itemName);
	
	
	switch (type)
    {
        case MIDI_SYSEX_PATCH_TRANSFER:
        case MIDI_SYSEX_PATCH_BANK_TRANSFER:
        	document.getElementById("patchesList").childNodes[row + 1].text = itemName;
            break;
        case MIDI_SYSEX_PATTERN_TRANSFER:
        case MIDI_SYSEX_PATTERN_BANK_TRANSFER:
        	document.getElementById("patternsList").childNodes[row + 1].text = itemName;
            break;
        case MIDI_SYSEX_SEQUENCE_TRANSFER:
        case MIDI_SYSEX_SEQUENCE_BANK_TRANSFER:
        	document.getElementById("sequencesList").childNodes[row + 1].text = itemName;
            break;
    } 
	
	/*
   if (row < 9)
        item->setText(QString("[0") + QString::number(1 + row) + "] " + itemName);
    else
        item->setText(QString("[") + QString::number(1 + row) + "] " + itemName);*/
       
}






